#ifndef _SERVER_H_
#define _SERVER_H_

#include "base.h"

typedef struct {
	char *key;
	char *value;
} two_strings;
//add by Allen
#ifdef CONFIG_SW5_LIGHTTPD_BASIC_AUTH
#define DEVICE_MODE		"/proc/device_mode"
#define CONN_STATE		"/proc/conn_state"
#define TMP_DEVICE_MODE	"/var/tmp/device_mode"
#define APCLI_STATUS				"/var/tmp/apcli0_status"
#define NO_PASSWORD_PATH "/var/tmp/no_passwd_mode"
#define TEST_MODE_PATH "/tmp/test_mode"
#define BLANK_STATUS_PATH "/var/tmp/blankstatus"

struct peer_info {
	char ip[20];
	char mac[18];
	char hostname[16];
} ;
struct mac_info {
	char login_mac_address[18];
} ;
#endif
//end by Allen
typedef enum { CONFIG_UNSET, CONFIG_DOCUMENT_ROOT } config_var_t;

int config_read(server *srv, const char *fn);
int config_set_defaults(server *srv);
buffer *config_get_value_buffer(server *srv, connection *con, config_var_t field);

#endif

//add by Allen
#ifdef CONFIG_SW5_LIGHTTPD_BASIC_AUTH
extern int long_login_time;
extern struct itimerval interval;
extern struct peer_info remote_info;
extern struct mac_info now_mac_info;
extern int firstlogin;
extern int eject_connect(void);
extern int check_login_time_auth(void);
extern int reset_login_timer(void);
extern int fail_login_count;
extern char now_login_ip[20];
#endif